package biggests.utils;

import java.awt.Color;
import javax.swing.JComponent;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class HeatmapColorScheme {
    public static final int RED_GREEN_SCHEME = 0;
    public static final int YELLOW_BLUE_SCHEME = 1;

    private static int heatmapColorScheme = RED_GREEN_SCHEME;

    public static int getHeatmapColorScheme() {
        return heatmapColorScheme;
    }

    public static void setHeatmapColorScheme(int heatmapColorScheme) {
        if (heatmapColorScheme != RED_GREEN_SCHEME &&
            heatmapColorScheme != YELLOW_BLUE_SCHEME)
            return;
        HeatmapColorScheme.heatmapColorScheme = heatmapColorScheme;
    }

    public static Color getMissingValueColor() {
        if (heatmapColorScheme == RED_GREEN_SCHEME) {
            return Color.yellow;
        }
        else if (heatmapColorScheme == YELLOW_BLUE_SCHEME) {
            return Color.white;
        }
        return null;
    }

    public static Color getMeanValueColor() {
        return Color.black;
    }

    public static Color getColorBelowMean(int component) {
        if (heatmapColorScheme == RED_GREEN_SCHEME) {
            return new Color(0, component, 0);
        }
        else if (heatmapColorScheme == YELLOW_BLUE_SCHEME) {
            return new Color(0, 0, component);
        }
        return null;
    }

    public static Color getColorAboveMean(int component) {
        if (heatmapColorScheme == RED_GREEN_SCHEME) {
            return new Color(component, 0, 0);
        }
        else if (heatmapColorScheme == YELLOW_BLUE_SCHEME) {
            return new Color(component, component, 0);
        }
        return null;
    }

    public static Color getBackgroundHighlightColor() {
        if (heatmapColorScheme == RED_GREEN_SCHEME) {
            return Color.green;
        }
        else if (heatmapColorScheme == YELLOW_BLUE_SCHEME) {
            return Color.blue;
        }
        return null;
    }

    public static Color getForegroundHighlightColor() {
        if (heatmapColorScheme == RED_GREEN_SCHEME) {
            return Color.black;
        }
        else if (heatmapColorScheme == YELLOW_BLUE_SCHEME) {
            return Color.white;
        }
        return null;
    }

    public static void setBackAndForegroundHighlightColors(JComponent component) {
        switch(heatmapColorScheme) {
        case RED_GREEN_SCHEME:
            component.setBackground(Color.green);
            component.setForeground(Color.black);
            break;
        case YELLOW_BLUE_SCHEME:
            component.setBackground(Color.blue);
            component.setForeground(Color.white);
            break;
        }
    }
}
